module AnyError(
	AnyError(AnyError),
	AnyException
    ) where

import Control.Monad.Error
import System.Exit
import Exception
import Subexception

-- Called "Any" because it is suitable to be the root of the exception
-- type hierarchy, so that its handler may be called on to deal with
-- all sources of errors.

data AnyError = AnyError String
	deriving (Show)
instance Error AnyError where
	strMsg = AnyError

type AnyException = ErrorT AnyError IO

instance Exception AnyError IO where
	-- Nothing to catch.
	mayCatchException act handler = act
	-- Any unhandled exception causes immediate exit.
	throwException (AnyError msg) = do
	    putStrLn $ "Exiting with unhandled error: " ++ msg
	    exitFailure

instance Subexception AnyError AnyError IO where
	inject = id
