module Main where

import Exception
import Subexception
import AnyError
import FTPError
import Control.Monad.Trans
import System.Exit

main = runException $
	runException $ do
	    ftp("ftp.kernel.org")
	    (   cwd "/pub/linux/kernel/v2.4"
		`catchException` (\(ErrorPerm e) -> liftIO $ do
		    putStrLn ("caught temp error in cwd: " ++ e)
		    exitWith (ExitFailure 2))
	     )
	    retrbinary "RETR ChangeLog-2.4.13" 
		    (\block -> write block)
	    quit
	`catchException` (\(ErrorPerm e) -> liftIO $ do
	    putStrLn ("Permissions error " ++ e)
	    exitWith (ExitFailure 2))
	`catchException` (\(ErrorTemp e) -> liftIO $ do
	    putStrLn ("Temporary error, please try again later " ++ e)
	    exitWith (ExitFailure 1))
	`catchException` (\(FTPError e) -> liftIO $ do
	    putStrLn ("Other FTP error " ++ e)
	    exitWith (ExitFailure 2))
	`catchException` (\(AnyError e) -> liftIO $ do
	    putStrLn ("Non-FTP error " ++ e)
	    exitWith (ExitFailure 3))
